/* 
 * This is a simple Tag Management Interface using Bitmap. 
 * I'd like to check the tag allocated and free. So I use Bitmap instead of Napa TagPool. 
 */
#include "stdafx.h"

void Tag_Initialize(PU32 TagBitmap)
{
	*TagBitmap=0;
}

U32 Tag_Allocate(PU32 TagBitmap)
{
	unsigned int i;
	for ( i=0; i<TAG_BITMAP_LENGTH; i++ )
	{
		if ( !((*TagBitmap)&(1<<i)) )
		{
			*TagBitmap |= (1<<i);
			return i;
		}
	}

	OSD_DASSERT(FALSE);
	return TAG_BITMAP_LENGTH;
}

BoOL Tag_InUse(PU32 TagBitmap, U32 Tag)
{
	OSD_DASSERT(Tag<TAG_BITMAP_LENGTH);
	return (*TagBitmap)&(1<<Tag);
}

void Tag_Free(PU32 TagBitmap, U32 Tag)
{
	OSD_DASSERT(Tag_InUse(TagBitmap, Tag));
	(*TagBitmap)&=~(1<<Tag);
}
